<template>
  <div class="wrapper" @click="click">
    <div class="input">
      <template v-if="getType() === 'radio'"
        ><radio :selected="selected"
      /></template>
      <template v-if="getType() === 'checkbox'"
        ><checkbox :selected="selected"
      /></template>
    </div>
    <div class="label">
      <slot />
    </div>
  </div>
</template>

<script>
import Radio from "./Radio";
import Checkbox from "./Checkbox";

export default {
  inject: ["getValue", "updateValue", "getType"],

  props: {
    value: null
  },

  components: {
    Radio,
    Checkbox
  },

  computed: {
    selected() {
      return !!~this.getValue().indexOf(this.value);
    }
  },

  methods: {
    click() {
      var value = this.getValue();
      if (this.selected) {
        value = value.filter(vi => vi !== this.value);
      } else {
        value.push(this.value);
      }
      this.updateValue(value);
    }
  }
};
</script>

<style lang="scss" scoped>
.wrapper {
  display: flex;
  align-items: center;
  cursor: pointer;
}

.input {
  width: 14px;
  height: 14px;
  line-height: 14px;
  display: inline-block;
  margin-right: 10px;
}

.label {
  display: inline-block;
  width: 100%;
}
</style>
